import type { DefineComponent, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, PropType } from 'vue';
import { ScrollPosition, VueNode } from './interface';
declare const _default: DefineComponent<{
    scrollPosition: {
        type: PropType<ScrollPosition>;
        default: null;
    };
    useIntersectionObserver: {
        type: BooleanConstructor;
        default: boolean;
    };
    threshold: {
        type: NumberConstructor;
        default: number;
    };
    onVisible: {
        type: PropType<() => void>;
        default: () => void;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    width: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: PropType<VueNode>;
        default: () => void;
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    scrollPosition: {
        type: PropType<ScrollPosition>;
        default: null;
    };
    useIntersectionObserver: {
        type: BooleanConstructor;
        default: boolean;
    };
    threshold: {
        type: NumberConstructor;
        default: number;
    };
    onVisible: {
        type: PropType<() => void>;
        default: () => void;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    width: {
        type: NumberConstructor;
        default: number;
    };
    placeholder: {
        type: PropType<VueNode>;
        default: () => void;
    };
}>>, {
    scrollPosition: ScrollPosition;
    height: number;
    width: number;
    useIntersectionObserver: boolean;
    threshold: number;
    placeholder: VueNode;
    onVisible: () => void;
}, {}>;
export default _default;
