import { defineComponent as S, shallowRef as D, computed as h, onMounted as _, createVNode as b, reactive as X, onBeforeUnmount as K, watch as H, mergeProps as L, ref as Q, isVNode as p } from "vue";
function B() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const E = {}, ee = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible();
  });
}, te = (e) => (E[e] = E[e] || new IntersectionObserver(ee, {
  rootMargin: e + "px"
}), E[e]), $ = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, z = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, U = /* @__PURE__ */ S({
  name: "PlaceholderWithoutTracking",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e) {
    const t = D(), n = h(() => !e.scrollPosition && e.useIntersectionObserver && B()), a = h(() => n.value ? te(e.threshold) : null);
    function o(l = e.scrollPosition) {
      const r = t.value.getBoundingClientRect(), s = t.value.style, f = {
        left: parseInt(s.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(s.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: l.y + r.bottom + f.top,
        left: l.x + r.left + f.left,
        right: l.x + r.right + f.left,
        top: l.y + r.top + f.top
      };
    }
    function d() {
      if (typeof window > "u" || t.value)
        return !1;
      const l = o(e.scrollPosition), r = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return r.top - e.threshold <= l.bottom && r.bottom + e.threshold >= l.top && r.left - e.threshold <= l.right && r.right + e.threshold >= l.left;
    }
    function u() {
      var l;
      d() && ((l = e.onVisible) == null || l.call(e));
    }
    _(() => {
      a.value && t.value && (t.value.onVisible = e.onVisible, a.value.observe(t.value)), n.value || u == null || u();
    });
    const i = h(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`
    }));
    return () => b("span", {
      ref: t,
      style: i.value
    }, [e.placeholder]);
  }
});
var ne = typeof global == "object" && global && global.Object === Object && global;
const re = ne;
var ie = typeof self == "object" && self && self.Object === Object && self, le = re || ie || Function("return this")();
const Y = le;
var oe = Y.Symbol;
const I = oe;
var G = Object.prototype, ae = G.hasOwnProperty, ce = G.toString, O = I ? I.toStringTag : void 0;
function ue(e) {
  var t = ae.call(e, O), n = e[O];
  try {
    e[O] = void 0;
    var a = !0;
  } catch {
  }
  var o = ce.call(e);
  return a && (t ? e[O] = n : delete e[O]), o;
}
var de = Object.prototype, fe = de.toString;
function se(e) {
  return fe.call(e);
}
var ye = "[object Null]", he = "[object Undefined]", A = I ? I.toStringTag : void 0;
function be(e) {
  return e == null ? e === void 0 ? he : ye : A && A in Object(e) ? ue(e) : se(e);
}
function ge(e) {
  return e != null && typeof e == "object";
}
var me = "[object Symbol]";
function ve(e) {
  return typeof e == "symbol" || ge(e) && be(e) == me;
}
var we = /\s/;
function Oe(e) {
  for (var t = e.length; t-- && we.test(e.charAt(t)); )
    ;
  return t;
}
var Se = /^\s+/;
function Pe(e) {
  return e && e.slice(0, Oe(e) + 1).replace(Se, "");
}
function T(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var F = 0 / 0, Le = /^[-+]0x[0-9a-f]+$/i, Ie = /^0b[01]+$/i, Te = /^0o[0-7]+$/i, je = parseInt;
function R(e) {
  if (typeof e == "number")
    return e;
  if (ve(e))
    return F;
  if (T(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = T(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Pe(e);
  var n = Ie.test(e);
  return n || Te.test(e) ? je(e.slice(2), n ? 2 : 8) : Le.test(e) ? F : +e;
}
var Ne = function() {
  return Y.Date.now();
};
const C = Ne;
var xe = "Expected a function", Ee = Math.max, Ce = Math.min;
function Z(e, t, n) {
  var a, o, d, u, i, l, r = 0, s = !1, f = !1, v = !0;
  if (typeof e != "function")
    throw new TypeError(xe);
  t = R(t) || 0, T(n) && (s = !!n.leading, f = "maxWait" in n, d = f ? Ee(R(n.maxWait) || 0, t) : d, v = "trailing" in n ? !!n.trailing : v);
  function g(c) {
    var y = a, m = o;
    return a = o = void 0, r = c, u = e.apply(m, y), u;
  }
  function k(c) {
    return r = c, i = setTimeout(w, t), s ? g(c) : u;
  }
  function V(c) {
    var y = c - l, m = c - r, x = t - y;
    return f ? Ce(x, d - m) : x;
  }
  function j(c) {
    var y = c - l, m = c - r;
    return l === void 0 || y >= t || y < 0 || f && m >= d;
  }
  function w() {
    var c = C();
    if (j(c))
      return N(c);
    i = setTimeout(w, V(c));
  }
  function N(c) {
    return i = void 0, v && a ? g(c) : (a = o = void 0, u);
  }
  function W() {
    i !== void 0 && clearTimeout(i), r = 0, a = l = o = i = void 0;
  }
  function M() {
    return i === void 0 ? u : N(C());
  }
  function P() {
    var c = C(), y = j(c);
    if (a = arguments, o = this, l = c, y) {
      if (i === void 0)
        return k(l);
      if (f)
        return clearTimeout(i), i = setTimeout(w, t), g(l);
    }
    return i === void 0 && (i = setTimeout(w, t)), u;
  }
  return P.cancel = W, P.flush = M, P;
}
var Be = "Expected a function";
function ke(e, t, n) {
  var a = !0, o = !0;
  if (typeof e != "function")
    throw new TypeError(Be);
  return T(n) && (a = "leading" in n ? !!n.leading : a, o = "trailing" in n ? !!n.trailing : o), Z(e, t, {
    leading: a,
    maxWait: t,
    trailing: o
  });
}
const Ve = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, We = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test(Ve(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, Me = (e) => /* @__PURE__ */ S({
  name: "ScrollAwareComponent",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    delayMethod: {
      type: String,
      default: "throttle"
    },
    delayTime: {
      type: Number,
      default: 300
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(n, {
    attrs: a
  }) {
    const o = h(() => n.useIntersectionObserver && B()), d = D(null), u = X({
      x: $(),
      y: z()
    });
    if (!o)
      return null;
    function i() {
      o || (u.x = $(), u.y = z());
    }
    const l = h(() => We(d.value));
    function r() {
      typeof window > "u" || o || (l.value.addEventListener("scroll", i), window.addEventListener("resize", i), l.value !== document.body && window.addEventListener("scroll", i));
    }
    function s() {
      typeof window > "u" || o || (l.value.removeEventListener("scroll", i), window.removeEventListener("resize", i), l.value !== document.body && window.removeEventListener("scroll", i));
    }
    _(() => {
      r();
    }), K(() => {
      s();
    }), H(l, (v, g) => {
      g && s(), r();
    });
    const f = n.delayMethod === "debounce" ? Z(i, n.delayTime) : ke(i, n.delayTime);
    return () => b(e, L(n, a, {
      scrollPosition: u,
      ref: d,
      onChangeScroll: f
    }), null);
  }
}), $e = /* @__PURE__ */ S({
  name: "PlaceholderWithTracking",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e, {
    attrs: t
  }) {
    return () => b(U, L(e, t), null);
  }
}), ze = Me($e), q = () => ({
  afterLoad: {
    type: Function,
    default: () => {
    }
  },
  beforeLoad: {
    type: Function,
    default: () => {
    }
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  visibleByDefault: {
    type: Boolean,
    default: !1
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  delayMethod: {
    type: String,
    default: "throttle"
  },
  delayTime: {
    type: Number,
    default: 300
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), Ae = () => ({
  ...q(),
  effect: {
    type: String,
    default: ""
  },
  placeholderSrc: {
    type: String,
    default: ""
  },
  wrapperClassName: {
    type: String,
    default: ""
  },
  wrapperProps: {
    type: Object,
    default: () => ({})
  },
  loadedClassName: {
    type: String,
    default: ""
  }
}), Fe = /* @__PURE__ */ S({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: q(),
  setup(e, {
    slots: t
  }) {
    var d, u;
    const n = X({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), a = h(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    H(n, (i, l) => {
      var r;
      i.visible !== (l == null ? void 0 : l.visible) && ((r = e.afterLoad) == null || r.call(e));
    }, {
      immediate: !0
    });
    const o = () => {
      var i;
      n.visible = !0, (i = e.afterLoad) == null || i.call(e);
    };
    return e.visibleByDefault && ((d = e.beforeLoad) == null || d.call(e), (u = e.afterLoad) == null || u.call(e)), () => {
      var i;
      return n.visible ? (i = t.default) == null ? void 0 : i.call(t) : a || e.useIntersectionObserver && B() ? b(U, {
        height: e.height,
        onVisible: o,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null) : b(ze, {
        height: e.height,
        onVisible: o,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null);
    };
  }
});
function Re(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !p(e);
}
const _e = /* @__PURE__ */ S({
  name: "LazyLoadImage",
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  props: Ae(),
  setup(e, {
    attrs: t
  }) {
    const n = Q(!1);
    function a() {
      return n.value ? null : () => {
        var r;
        (r = e.afterLoad) == null || r.call(e), n.value = !0;
      };
    }
    function o() {
      const r = h(() => {
        const {
          class: s,
          afterLoad: f,
          beforeLoad: v,
          delayMethod: g,
          delayTime: k,
          effect: V,
          placeholder: j,
          placeholderSrc: w,
          scrollPosition: N,
          threshold: W,
          useIntersectionObserver: M,
          visibleByDefault: P,
          wrapperClassName: c,
          wrapperProps: y,
          style: m,
          loadedClassName: x,
          ...J
        } = e;
        return J;
      });
      return b("img", L({
        onLoad: a()
      }, r.value, t), null);
    }
    function d() {
      let r;
      return b(Fe, {
        beforeLoad: e.beforeLoad,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, Re(r = o()) ? r : {
        default: () => [r]
      });
    }
    const u = h(() => n.value ? " lazy-load-image-loaded" : ""), i = h(() => n.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function l(r) {
      return b("span", L({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + u.value,
        style: {
          ...i.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [r]);
    }
    return () => {
      const r = d();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? r : l(r);
    };
  }
});
export {
  Fe as LazyLoadComponent,
  _e as LazyLoadImage,
  Me as trackWindowScroll
};
